<template>

  <v-card class="mx-auto" style="position: relative;">

    <span class="notification-badge" v-show="office.pros.length > 0" 
      @click="proModal.office = office; proModal.dialog = true; proModal.loadingButton = false; proModal.loadingPros = false;
      proModal.prosFound = []; proModal.prosToAdd = []; proModal.fieldText = 'Merci de saisir un nom ou un email'">
      <v-icon small color="white">mdi-pencil</v-icon>
    </span>

    <iframe width="100%" height="200" frameborder="0" style="border:0" allowfullscreen
            :src="'https://maps.google.com/maps?hl=fr&q=' + fullAddress(office) + '&ie=UTF8&z=13&output=embed'">
    </iframe>

    <v-chip v-if="office.status === officeStates.enabled" class="ml-3 mt-2 mb-0" color="success" small
            text-color="white">
      Validée
    </v-chip>
    <v-chip v-if="office.status === officeStates.waiting" class="ml-3 mt-2 mb-0" color="warning" small
            text-color="white">En
      attente
    </v-chip>
    <v-chip v-if="office.status === officeStates.archived" class="ml-3 mt-2 mb-0" color="error" small
            text-color="white">
      Archivée
    </v-chip>

    <v-card-title class="pt-2">{{ office.name }}</v-card-title>
    <v-card-subtitle>{{ office.title }}</v-card-subtitle>
    <v-card-text class="text--primary" v-if="office.description && office.description.length <= 200">{{ office.description | slice(200) }}</v-card-text>
    <v-card-actions>
      <v-row align="center" justify="space-between" class="px-3">

        <router-link :to="{name: 'Professional', params: {id: office.id}}" class="text-decoration-none" v-if="office.status === 1">
          <v-btn color="primary" small icon>
            <v-icon>mdi-eye</v-icon>
          </v-btn>
        </router-link>

        <v-btn v-if="isCreator"
               color="warning" small icon @click="updateModal.dialog = true; updateModal.office = office; updateModal.officeCache = Object.assign({}, office); updateModal.addItem = false">
          <v-icon>mdi-pencil-circle</v-icon>
        </v-btn>

        <v-btn v-if="office.status === officeStates.enabled && isCreator"
               color="error" small icon
               @click="removeModal.dialog = true; removeModal.office = office; removeModal.action = removeModal.actions.delete; removeModal.loading = false;">
          <v-icon>mdi-trash-can</v-icon>
        </v-btn>

        <v-btn v-else-if="office.status === officeStates.enabled"
               color="error" small icon
               @click="removeModal.dialog = true; removeModal.office = office; removeModal.action = removeModal.actions.quit; removeModal.loading = false;">
          <v-icon>mdi-exit-to-app</v-icon>
        </v-btn>

        <v-btn v-else-if="office.status === officeStates.waiting && isCreator"
               color="error" small icon
               @click="removeModal.dialog = true; removeModal.office = office; removeModal.action = removeModal.actions.cancel; removeModal.loading = false;">
          <v-icon>mdi-close-circle</v-icon>
        </v-btn>

      </v-row>
    </v-card-actions>
  </v-card>
</template>

<script>
export default {
  name: "OfficeCard",
  props: {
    office: Object,
    isCreator: Boolean,

    updateModal: Object,
    removeModal: Object,
    proModal: Object,
  },
  data() {
    return {
      officeStates: {
        enabled: 1,
        waiting: 0,
        archived: -1,
      },
    }
  },
  filters: {
    slice(text, size, moreText = '...') {
      return text.slice(0, size) + (text.length > size ? moreText : '');
    }
  },
  methods: {
    fullAddress(office) {
      return office.address + ', ' + office.postalCode + office.city + ', ' + office.country
    },
  }
}
</script>

<style lang="scss">
  .notification-badge {
    display: flex;
    align-items: center;
    justify-content: center;
    height: 30px;
    width: 30px;
    border-radius: 50% !important;
    color: white;
    background: var(--v-error-base);
    position: absolute;
    top: 0;
    right: 0;
    transform: translateX(50%) translateY(-50%) scale(1);
    animation: pulse 2s infinite;
    cursor: pointer;
  }

  @keyframes pulse {
    0% {
      transform: translateX(50%) translateY(-50%) scale(0.95);
      box-shadow: 0 0 0 0 rgba(0, 0, 0, 0.4);
    }

    70% {
      transform: translateX(50%) translateY(-50%) scale(1.15);
      box-shadow: 0 0 0 10px rgba(0, 0, 0, 0);
    }

    100% {
      transform: translateX(50%) translateY(-50%) scale(0.95);
      box-shadow: 0 0 0 0 rgba(0, 0, 0, 0);
    }
  }

</style>
